#ifndef DISPLAY_H
#define DISPLAY_H

#include "mbed.h"
#include "N5110.h"


class Display
{

public:
    Display();
    ~Display();
    void init();
    void drawCircle(N5110 &lcd); 
    void random_instruction(N5110 &lcd); 
    void Circle(N5110 &lcd); 
    

     
private:
    void calculateWait();   
    void circle_refresh();
    void Drawarc(N5110 &lcd, int a);
    int _h;
    float _w;
    int _a;
    int _A; 
    int _v; 
    int x; 
    int y;  
    int x0;
    int y0;
    int radiusError;

};
#endif